use r2d2_postgres::postgres::NoTls;
use r2d2_postgres::PostgresConnectionManager;
use std::ops::Deref;
use std::sync::{Arc, Mutex};

pub enum Pool {
    Postgres(r2d2::Pool<PostgresConnectionManager<NoTls>>),
}

pub enum Client {
    Postgres(r2d2::PooledConnection<PostgresConnectionManager<NoTls>>),
}

static mut POOL: Option<Arc<Mutex<Pool>>> = None;

pub fn init() {
    let manager = PostgresConnectionManager::new(
        "host=localhost user=postgres dbname=test".parse().unwrap(),
        NoTls,
    );

    let pool = r2d2::Pool::new(manager).unwrap();
    unsafe {
        POOL = Some(Arc::new(Mutex::new(Pool::Postgres(pool))));
    }
}

pub fn client() -> Client {
    match unsafe { POOL.as_ref().unwrap().clone().lock().unwrap().deref() } {
        Pool::Postgres(pool) => Client::Postgres(pool.get().unwrap()),
    }
}
