use crate::database;
use serde::{Deserialize, Serialize};
use serde_json;

pub fn endpoint(endpoint: &str, input: serde_json::Value) -> serde_json::Result<serde_json::Value> {
    match endpoint {
        "echo" => Ok(serde_json::to_value(echo(serde_json::from_value(input)?))?),
        _ => Ok("{}".into()),
    }
}

#[derive(Serialize, Deserialize)]
pub struct EchoInput {
    message: String,
}

#[derive(Serialize, Deserialize)]
pub struct EchoOutput {
    message: String,
    database: Option<i32>,
}

pub fn echo(input: EchoInput) -> EchoOutput {
    let backend = database::client();
    let mut output = EchoOutput {
        message: input.message,
        database: None,
    };
    match backend {
        database::Client::Postgres(mut client) => {
            let res = client.query("SELECT * FROM test", &[]).unwrap();
            for row in res {
                output.database = Some(row.get(0));
            }
        }
    }
    output
}
